package tanzaku;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Graphics2D;
import java.awt.GraphicsEnvironment;
import java.awt.Rectangle;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.geom.AffineTransform;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;

import javax.imageio.ImageIO;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollBar;
import javax.swing.JScrollPane;
import javax.swing.JSlider;
import javax.swing.ScrollPaneConstants;
import javax.swing.border.LineBorder;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;


public class Straighten extends JFrame implements ChangeListener, ActionListener {

	JLabel label;

	JSlider slider;

	int fontsize = 20;

	JButton image_button;
	Rectangle rect;
	JButton decision;

	BufferedImage readImage = null;


	int width = 0;
	int height = 0;

	double Affine=0.001;

	String filename;

	Straighten(String filename) {

		this.filename = filename;

		GraphicsEnvironment env = GraphicsEnvironment.getLocalGraphicsEnvironment();
		rect = env.getMaximumWindowBounds();

		slider = slider();
		slider.addChangeListener(this);

		JPanel p = srider_panel(rect);

		JPanel pl = srider_num_panel(rect);

		decision.addActionListener(this);

		/***********************************************************/
		try {
			readImage = ImageIO.read(new File(filename));
		} catch (Exception e) {
			e.printStackTrace();
			readImage = null;
		}

		width = readImage.getWidth();
		height = readImage.getHeight();

		try {
			ScaleJPG.scale(//
					filename, //
					width, //
					height + 100,//
					filename,//
					0.0, //
					0.0//
			);

		} catch (Exception e) {
			e.printStackTrace();
		}



		Zoom zoom = new Zoom(
		readImage, //

				0, //
				0, //
				width, height,//

				0, //
				0, //
				width, height//
		);


		image_button = new JButton();
		image_button.setBackground(Color.blue);
		image_button.add(zoom);
		image_button.setPreferredSize(new Dimension(rect.width, rect.height * 2));
		/*********************/

		JPanel main_panel = new JPanel();
		main_panel.setPreferredSize(new Dimension(rect.width, rect.height * 2));
		main_panel.add(image_button);

		JScrollPane scrollpane = new JScrollPane(main_panel);
		scrollpane.getVerticalScrollBar().setUnitIncrement(1000);
		scrollpane.setPreferredSize(new Dimension(rect.width, rect.height));

//		JScrollBar jScrollBar = new JScrollBar();
//		jScrollBar.setPreferredSize(new Dimension(100, 100));
//		jScrollBar.setBackground(Color.black);
//		jScrollBar.setForeground(Color.white);
//
//		jScrollBar.setBlockIncrement(rect.height - 200); //横ｽｸﾛｰﾙﾊﾞｰのつまみ("サム")をドラッグした場合の移動量
//		jScrollBar.setUnitIncrement(rect.height - 200); //横ｽｸﾛｰﾙﾊﾞｰの左右矢印ボタンをクリックした場合の移動量
//
//		// JScrollBar.set
//
//		scrollpane.setVerticalScrollBar(jScrollBar);

		scrollpane.setVerticalScrollBarPolicy(ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS);

		this.add(scrollpane, BorderLayout.CENTER);

		this.getContentPane().add(p, BorderLayout.PAGE_START);
		//this.getContentPane().add(pl, BorderLayout.EAST);
		this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		this.setBounds(0, 0, rect.width, rect.height);

		this.setTitle("タイトル");
		this.setVisible(true);
	}

	public JPanel srider_num_panel(Rectangle rect) {

		JPanel pl = new JPanel(new BorderLayout());
		pl.setPreferredSize(new Dimension(250, rect.height - 200));
		label = new JLabel();
		label.setText("値：" + slider.getValue());
		label.setFont(new Font("", Font.BOLD, fontsize));
		label.setForeground(Color.WHITE);
		label.setBackground(Color.black);
		pl.setBackground(Color.black);
		pl.add(label, BorderLayout.CENTER);

		return pl;
	}

	public JPanel srider_panel(Rectangle rect) {

		decision = new JButton("<html>適<br>用");

		decision.setPreferredSize(new Dimension(100, 100));
		decision.setBorder(new LineBorder(Color.gray, 10, true));
		decision.setBackground(Color.white);
		decision.setForeground(Color.black);
		decision.setOpaque(true);
		decision.setBorderPainted(false);

		decision.setFont(new Font("", Font.BOLD, 20));

		JPanel p = new JPanel(new BorderLayout());
		p.setPreferredSize(new Dimension(rect.width, 100));

		p.setForeground(Color.WHITE);
		p.setBackground(Color.black);

		p.add(slider, BorderLayout.CENTER);

		p.add(decision, BorderLayout.EAST);

		return p;
	}

	public JSlider slider() {
		slider = new JSlider(0, -10, 10, 0
				);

		slider.setPreferredSize(new Dimension(800, 50));
		slider.setFont(new Font("", Font.BOLD, fontsize));
		slider.setPaintTicks(true);
		slider.setMajorTickSpacing(1);
		slider.setSnapToTicks(true);
		slider.setLabelTable(slider.createStandardLabels(1));
		slider.setPaintLabels(true);
		slider.setForeground(Color.WHITE);
		slider.setBackground(Color.black);
		return slider;
	}

	public void stateChanged(ChangeEvent e) {

		label.setText("値：" + slider.getValue());
		System.out.println("値：" + slider.getValue());

		BufferedImage bdest = new BufferedImage(width, height, BufferedImage.TYPE_INT_RGB);
		Graphics2D g = bdest.createGraphics();
		AffineTransform at = AffineTransform.getShearInstance(0.0, Affine * slider.getValue());

		g.drawRenderedImage(readImage, at);

		if (at != null) {
			g.setTransform(at);
		}

		Zoom zoom = new Zoom(bdest, //
									// ボタンに乗せる画像
				0, //
				0, //
				width, height,//

				0, //
				0, //
				width, height//
		);

		image_button.removeAll();
		image_button.add(zoom);
		image_button.validate();

		this.setVisible(true);
	}

	public static void main(String[] args) {

		new Straighten("C:/11_workspace_timecard/tasuki21/src/tanzaku21/入門経済学　スティグリッツ0006.jpg");

	}

	@Override
	public void actionPerformed(ActionEvent e) {

		if (decision == e.getSource()) {

			BufferedImage bsrc = null;

			try {
				bsrc = ImageIO.read(new File(filename));
			} catch (IOException e1) {
				// TODO 自動生成された catch ブロック
				e1.printStackTrace();
			}

			BufferedImage bdest = new BufferedImage(width, height, BufferedImage.TYPE_INT_RGB);
			Graphics2D g = bdest.createGraphics();

			label.setText("actionPerformed値：" + slider.getValue());

			System.out.println("actionPerformed値：" + 0.0001 * slider.getValue());

			AffineTransform at = AffineTransform.getShearInstance(0.0, Affine * slider.getValue());

			g.drawRenderedImage(bsrc, at);

			if (at != null) {
				g.setTransform(at);
			}

			try {
				ImageIO.write(bdest, "JPG", new File(filename));
			} catch (IOException e1) {
				// TODO 自動生成された catch ブロック
				e1.printStackTrace();
			}

			this.dispose();
		}
	}
}